<?php
/**
 * +-------------------------------------------------------------------+
 * |                        7t-File Manager                            |
 * |                                                                   |
 * | Copyright Ankur Sharma               http://www.7tech.co.in       |
 * |                                                                   |
 * +-------------------------------------------------------------------+
 * | This program may be used and hosted free of charge by anyone for  |
 * | personal purpose as long as this copyright notice remains intact. |
 * |                                                                   |
 * | Obtain permission before selling the code for this program or     |
 * | hosting this software on a commercial website or redistributing   |
 * | this software over the Internet or in any other medium. In all    |
 * | cases copyright must remain intact.                               |
 * +-------------------------------------------------------------------+
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

include('other/functions.php'); 
 
class filemanagerController extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		if(isset($_REQUEST['ajax_request']) && $_REQUEST['ajax_request']){
			$fm=new FileManagerMain();
			$ajax_result=array("success"=>0,"data"=>"","error"=>"");
			if(isset($_POST['get_left_col_sub_dir'])){
				$ajax_result["success"]=1;
				$ajax_result['data']=$fm->get_left_col_sub_dir($_POST['get_left_col_sub_dir']);
			} else if(isset($_POST['get_right_col_sub_dir'])){
				$ajax_result["success"]=1;
				if(isset($_POST['get_left_sub_dir_too']) && $_POST['get_left_sub_dir_too']){
					$ajax_result['left_sub_dir']=$fm->get_left_col_sub_dir($_POST['get_right_col_sub_dir']);
				}
				$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['get_right_col_sub_dir']);
			}else if(isset($_POST['create_new_file'])){
				$path = $fm->get_root_path().implode("/",$_POST['path'])."/";
				if( !is_file($path.$_POST['create_new_file']) && !is_dir($path.$_POST['create_new_file'])){
					$FileHandle = @fopen($path.$_POST['create_new_file'], 'w') ;
					fclose($FileHandle);
					$ajax_result["success"]=1;
					$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['path']);
				}else{
					$ajax_result['error']="File already exist!";
				}		
			}else if(isset($_POST['create_new_folder'])){
				$path = $fm->get_root_path().implode("/",$_POST['path'])."/";
				if( !is_dir($path.$_POST['create_new_folder']) && !is_file($path.$_POST['create_new_folder'])){
					$ajax_result["success"]=mkdir($path.$_POST['create_new_folder'], 0755);
					$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['path']);
					$ajax_result['left_sub_dir']=$fm->get_left_col_sub_dir($_POST['path']);
				}else{
					$ajax_result['error']="Folder already exist!";
				}	
			}else if(isset($_POST['delete_files'])){
				$path = $fm->get_root_path().implode("/",$_POST['path'])."/";
				$ajax_result["success"]=1;
				foreach($_POST['delete_files'] as $filename){
					if(is_dir($path.$filename)){
						if(!$fm->rrmdir( $path.$filename)){ 
							$ajax_result["success"]=0; $ajax_result['error'].='Folder "'.$filename.'" can not be deleted! '."\n"; 
						}
					}else if(is_file($path.$filename)){
						if(!unlink( $path.$filename)){ 
							$ajax_result["success"]=0; $ajax_result['error'].='File "'.$filename.'" can not be deleted! '."\n"; 
						}			
					}else{
						$ajax_result["success"]=0;
						$ajax_result['error']='File/Folder "'.$filename.'" does not exist! '."\n";
					}
				}
				$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['path']);
				$ajax_result['left_sub_dir']=$fm->get_left_col_sub_dir($_POST['path']);		
			}else if(isset($_POST['upload_files_path'])){
				define('NO_DIRECT_ACCESS', true);
				$hideresult=1;
				$targetDir =  $fm->get_root_path().$_POST['upload_files_path']."/";
				include('other/upload.php');
				$ajax_result["success"]=1;
			}else if(isset($_REQUEST['filepath_for_edit'])){
				$targetFile =  $fm->get_root_path().$_REQUEST['filepath_for_edit'].'/'.$_REQUEST['filename'];
				if(is_file($targetFile)){ 
					if(isset($_POST['reload']) && $_POST['reload']){
						ob_start();
						readfile($targetFile);
						$ajax_result["data"]=ob_get_contents();
						ob_end_clean();
						$ajax_result["success"]=1;
					}else if(isset($_POST['save'])){
						if($file = @fopen($targetFile,"w")){
							fwrite($file,$_POST['save']);
							fclose($file);
							$ajax_result["success"]=1;
						}else{
							$ajax_result["success"]=0;
							$ajax_result["error"]="Can not open file.";
						}
					}else{
						define('NO_DIRECT_ACCESS', true);
						$ext=strrpos($_REQUEST['filename'],".")>0?strtolower(substr($_REQUEST['filename'],strrpos($_REQUEST['filename'],".")+1)):"html";
						$ext=$ext=="txt"?"html":$ext;
						include('other/file_editor.php');
						die();
					}
				}else{
					$ajax_result["success"]=0;
					$ajax_result["error"]="Wrong file path.";
				}
			}else if(isset($_POST['new_name'])){
				$path = $fm->get_root_path().implode("/",$_POST['path'])."/";
				if(file_exists($path.$_POST['new_name'])){
					$ajax_result["success"]=0;
					$ajax_result['error']='File/Folder "'.$_POST['new_name'].'" already exist! '."\n";
				}else{
					rename($path.$_POST['old_name'],$path.$_POST['new_name']);
					$ajax_result["success"]=1;
					$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['path']);
					$ajax_result['left_sub_dir']=$fm->get_left_col_sub_dir($_POST['path']);	
				}
			}else if(isset($_POST['change_permission'])){
				$path = $fm->get_root_path().implode("/",$_POST['path'])."/";
				foreach($_POST['change_permission'] as $filename){
					if(file_exists($path.$filename)){
						chmod($path.$filename, octdec($_POST['permission_val']));
					}
				}
				$ajax_result["success"]=1;
				$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['path']);
			}else if(isset($_REQUEST['download_file'])){
				$filename=$_REQUEST['download_file'];
				$fullpath=$fm->get_root_path().$_REQUEST['download_file_path']."/".$filename;
				header("Content-Type: application/octet-stream");
				header("Content-Length: ".filesize($fullpath));
				header("Content-Disposition: attachment; filename=$filename");
				readfile($fullpath);
				die();
			}else if(isset($_POST['destination_path_for_copy'])){
				$path = $fm->get_root_path().implode("/",$_POST['path'])."/";
				$dpath = $fm->get_root_path().((substr($_POST['destination_path_for_copy'],0,1)=="/")?substr($_POST['destination_path_for_copy'],1):$_POST['destination_path_for_copy']);
				$dpath = str_replace("\\","/",$dpath);
				$dpath = (substr($dpath,-1)=="/")?$dpath:$dpath.'/';
				$ajax_result["success"]=1;
				$count=0;
				foreach($_POST['files'] as $fname)
				{
					if(file_exists($dpath.$fname)){
						$ajax_result["success"]=0;
						$ajax_result["error"]="File exist";
					}
				}
				if($ajax_result["success"]!=0){
					if(!file_exists($dpath)){
						@mkdir( $dpath,0755,true);
					}
					foreach($_POST['files'] as $fname)
					{
						if(!$fm->copy_dir($path.$fname,$dpath.$fname)){
							$ajax_result["success"]=0;
							$ajax_result["error"]="Error while copying ";
						}else{
							$count++;
						}		
					}
				}
				if($count){
					$ajax_result['data']=$fm->get_right_col_sub_dir($_POST['path']);
					$ajax_result['left_sub_dir']=$fm->get_left_col_sub_dir(explode("/",$dpath));	
				}
			}
			echo json_encode($ajax_result);
			exit();
		}
	
		parent::display();
	}

}